;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: altacceptor.lisp,v 1.3 2004/02/22 00:46:56 dvm Exp $

(depends-on %module/ ytools)

(depends-on :at-run-time %nity/  subtype altformer)

(end-header)

;;; This one has higher priority, because (alt a b) is a subtype
;;; of (alt c d) if and only if a and b are both subtypes of (alt c d).
(declare-class-feature got-me-want-other (alt-class :universal)
	 (make-Accept-handler 35
	     (\\ (ctv me other undo-stack envm envo accept-stack)
		;(out (tr got-alt-class ("got-alt-class> " me 1 other)
		(multiple-value-let (alts envm foundm)
				    (type-find-feature-spread
				         me 'alt-types envm)
		   (cond ((not foundm)
			  (error-break alt-got-me-want-other :fatal
			     "Alt with no alt-types: " me)))
		   ;;(out "alts = " alts :%)
		   (repeat :for ((a :in alts)
				okay)
		    :result (values true undo-stack)
		      (!= < okay undo-stack >
			  (type-acceptable
			     ctv a other undo-stack envm envo accept-stack))
		    :while okay
		    else :result (values false undo-stack)))
		;("got-alt-class< " out-vals*)))
		)))

(defvar alt-dbg* false)

(declare-class-feature got-other-want-me (alt-class :universal)
   (make-Accept-handler 25
	(\\ (ctv other me undo-stack envo envm accept-stack)
	  (dbg-out alt-dbg*
	     "Alt: Testing " other
	     :% " vs. " me )
	  (multiple-value-let (alts envm foundm)
			      (type-find-feature-spread
				 me 'alt-types envm)
	     (cond ((not foundm)
		    (error-break alt-got-other-want-me :fatal
		       "Alt with no alt-types: " me)))
	      (repeat :for ((a :in alts)
			   okay
			   ;; A list of undo-stacks:
			   (possibles '())
			   ;; A list of Type-closures:
			   (necessaries '())
			   ustack)
	       :result (progn
			  (dbg-out alt-dbg*
			     "Alt: " (len necessaries) " necessary supertypes,"
			     :% 4 (len possibles) " possible supertypes" :%)
			  (cond ((null necessaries)
				 (cond ((null possibles)
					(dbg-out alt-dbg* "Alt: Fail" :%)
					(values false undo-stack))
				       ((null (cdr possibles))
					(dbg-out alt-dbg*
					    "Alt: Constraining vars" :%)
					(values
					   true
					   (redo undo-stack (car possibles))))
				       (t
					(dbg-out alt-dbg*
					    "Alt: Imposed constraint" :%)
					(values
					   true
					   (acceptability-constraint-post
					      ctv other me undo-stack
					      envo envm
					      ;; see note in subtype,
					      ;; defn. of
					      ;; acceptability-constraint-post
					      (accept-stack-pop
					         accept-stack))))))
				((null (cdr necessaries))
				 (dbg-out alt-dbg*
				    "Alt: Obvious" :%)
				 (values true undo-stack))
				(t
				 (dbg-out alt-dbg*
				    "Alt: Have to order necessary supertypes")
				 (multi-let (((consis _ undo-stack-2)
					      (typelist-try-order
						 necessaries undo-stack
						 accept-stack)))
				    (okay-or-undo
				       consis undo-stack-2 undo-stack)))))
		 (dbg-out alt-dbg*
		    "Testing alternative " a :%)
		 (!= < okay ustack >
		     (type-acceptable
			ctv other a undo-stack envo envm accept-stack))
		 (cond (okay
			(cond ((eq ustack undo-stack)
			       (dbg-out alt-dbg*
				  "Necessary supertype: " a :%)
			       (!= necessaries (cons (new-Type-closure
							a envm)
						     *-*)))
			      (t
			       (undo ustack undo-stack)
			       (dbg-out alt-dbg*
				  "Possible supertype: " a :%)
			       (!= possibles
				   (cons ustack *-*)))))
		       (t
			(dbg-out alt-dbg*
			   "Impossible as supertype" :%))))))))

(class-feature-datafun equal-tester (alt-class :universal)
   (defun (me other envm envo)
      (multiple-value-let (etl1 envm found)
                          (type-find-feature-spread me 'alt-types envm)
         (cond ((not found)
		(error-break alt-equal-tester :fatal
		   "Alt type with no component types: " me))
	       ((null etl1)
		(types-equal void-type* other envm envo))
	       ((null (cdr etl1))
		(types-equal (car etl1) other envm envo))
	       (t
		(multiple-value-let (etl2 envo found2)
				    (type-find-feature-spread
				       other 'alt-types envo)
		   (cond (found2
			  (and (type-list-is-sublist etl1 etl2 envm envo)
			       (type-list-is-sublist etl2 etl1 envo envm)))
			 (t
			  false))))))))

;;; Do all the types in tl1 occur in tl2?
(defun type-list-is-sublist (tl1 tl2 env1 env2)
   (forall (t1 in tl1)
      (exists (t2 in tl2)
	 (types-equal t1 t2 env1 env2))))

(class-feature-datafun is-builder (alt-class :universal)
   (defun (alty must-be-defined vartypes
	   is-tester-stack warn-if-undefined)
      (multiple-value-let (alt-types vartypes found)
			  (type-find-feature-spread
			     alty 'alt-types vartypes)
	 (cond (found
		(repeat :for ((at :in alt-types)
			     (istl '()) ist)
		 :result `(lambda (x)
			    (or ,@(<# (\\ (ist)
					 (build-funform ist '(x)))
				      (reverse istl))))
		   (!= ist (get-is-tester at must-be-defined
					  vartypes is-tester-stack
					  warn-if-undefined))
		 :until (or (not ist) (eq ist '*untestable))
		 :result '*untestable
		   (!= istl `(,ist ,@*-*))))
	       (t
		(error-break alt-class-is-builder :fatal
		   "Alt with no alt-types: " alty))))))

(class-feature-datafun scope-time-checker alt-class
   (defun (ty scope-time bound-unks undo-stack env)
      (typelist-freevars-scope-check
	 (type-find-feature ty 'alt-types env)
         scope-time bound-unks undo-stack env)))

