;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)

(depends-on %module/ ytools)

(depends-on :at-run-time %ytools/ filedeps %hacks/ dagprint filedag)

(defun nity-files-display ()
   (let ((nmod (yt::place-YT-module 'nity)))
      (let ((act (yt::YT-module-contents nmod)))
         (let-fun ()
	    (let ((nl (find-nity-files)))
	       (cond (nl
		      (file-deps-display
			 (nity-depends-list nl)))
		     (t
		      (signal-problem nity-files-display
			 "Can't extract files from contents of 'nity' module:"
			 :% act))))
	  :where
	    (:def find-nity-files ()
	       (match-cond act
		  ?( (progn ?_ (depends-on ?@fl))
		    (memq '%nity/ fl))
		  (t false)))))))

(defvar nity-need-at-run-time*
        '("types" "foundation" "typevar" "vartypes" "feature" "alttype" "tuptypes"
	  "trecycle" "desigsubst" "dottypes" "funtypes" "contype"))

;;; 'need-at-compile-time' is a list of strings (e.g., ("types" "foundation" ...))
(defun nity-depends-list (filespecs)
   (repeat :for ((pn :in (union (filespecs->pathnames filespecs)
				(files-run-time-deps filespecs)
				:test #'yt::pn-equal))
		 (nity-dir (Pathname-directory
			      (car (filespecs->pathnames '(%nity/ types.lisp))))))
    :when (in-nity-dir pn)
    :within
       (let ((pn-run-time-deps
	        (<? is-Pathname
		    (yt::Load-progress-rec-run-time-depends-on
		       (yt::place-load-progress-rec pn))))
	     (name (Pathname-name pn)))
;;;;	  (out "pn = " pn
;;;;	       :% "  deps = " pn-run-time-deps :%)
	  (:continue
	   :collect `(,@(include-if (member name nity-need-at-run-time*
					    :test #'string=)
			   '*)
		      ,(intern name)
		      <-
		      ,@(repeat :for ((dpn :in pn-run-time-deps))
			 :when (in-nity-dir dpn)
			 :collect (intern (Pathname-name dpn))))))
    :where

       (:def in-nity-dir (pn)
	   (equal (Pathname-directory pn)
		  nity-dir))))
