;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: dotacceptors-valtup.lisp,v 1.1 2006/03/09 16:11:02 dvm Exp $

(depends-on :at-run-time %nity/ tuptypes subtype feature dotformers
	                       typevar)

;;Dots and Lins can't be of same class, just as Tups and Args couldn't be
;; in old regime.  Ditto Ktps and Keys.

(class-feature-datafun is-builder dot-class
   (defun (dot-ty must-be-defined vartypes is-tester-stack warn-if-undefined)
      (let ((a-tester (get-is-tester
		         (type-find-feature dot-ty 'cartype vartypes)
			 must-be-defined vartypes is-tester-stack
			 warn-if-undefined))
	    (d-tester (get-is-tester
		         (type-find-feature dot-ty 'cdrtype vartypes)
			 must-be-defined vartypes is-tester-stack
			 warn-if-undefined)))
	 (cond ((and a-tester d-tester)
		`(lambda (x)
		    (and (is-Pair x)
			 (,a-tester (car x))
			 (,d-tester (cdr x)))))
	       (t false)))))

(class-feature-datafun equal-tester dot-class
   (defun (me other envm envo)
      (dot-lin-equal-tester 'Tup me other envm envo)))
       
(defun dot-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (dot-lin-subtyper ctv 'Tup got wanted undo-stack envg envw accept-stack))

(declare-class-feature got-me-want-other dot-class
   (make-Accept-handler 9 #'dot-subtyper))

(declare-class-feature got-other-want-me dot-class
   (make-Accept-handler 9 #'dot-subtyper))

(class-feature-datafun equal-tester lin-class
   (defun (me other envm envo)
      (dot-lin-equal-tester 'Row me other envm envo)))

(defun lin-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (dot-lin-subtyper ctv 'Row got wanted undo-stack envg envw accept-stack))

(declare-class-feature got-me-want-other lin-class
   (make-Accept-handler 10 #'lin-subtyper))

(declare-class-feature got-other-want-me lin-class
   (make-Accept-handler 10 #'lin-subtyper))

(defun dot-lin-equal-tester (med me other envm envo)
   (and (eq (Type-class other)
	    (cond ((eq med 'Tup) dot-class*)
		  (t lin-class*)))
	(types-equal (type-must-find-feature me 'cartype envm)
		     (type-must-find-feature other 'cartype envo)
		     envm envo)
	(types-equal (type-must-find-feature me 'cdrtype envm)
		     (type-must-find-feature other 'cdrtype envo)
		     envm envo)))

(defun dot-lin-subtyper (ctv med got wanted undo-stack envg envw accept-stack)
   (let ((class (cond ((eq med 'Tup) dot-class*)
		      (t lin-class*))))
      (letrec ()
	 (cond ((and (eq (Type-class got) class)
		     (eq (Type-class wanted) class))
		(multi-let (((a-okay undo-stack-2)
			     (type-acceptable
				ctv
				(type-must-find-feature
				   got 'cartype envg)
				(type-must-find-feature
				   wanted 'cartype envw)
				undo-stack envg envw accept-stack)))
		   (cond (a-okay
			  (finish
			     (type-must-find-feature
			        got 'cdrtype envg)
			     (type-must-find-feature
			        wanted 'cdrtype envw)
			     undo-stack-2))
			 (t
			  (values false (undo undo-stack-2 undo-stack))))))
;;;;	       ;; The usual possibilities: (Lin t1 t2) can turn into
;;;;	       ;; t1 if t2 can be construed as empty.
;;;;	       ((eq (Type-class got) lin-class*)
;;;;		(multi-let (((d-okay undo-stack-2)
;;;;			     (acceptable-as-degenerate-lin
;;;;				got undo-stack envg)))
;;;;		   (cond (d-okay
;;;;			  (finish
;;;;			     (type-must-find-feature
;;;;				got 'cartype envg)
;;;;			     wanted
;;;;			     undo-stack-2))
;;;;			 (t
;;;;			  (fail-and-undo undo-stack-2 undo-stack)))))
;;;;	       ((eq (Type-class wanted) lin-class*)
;;;;		(multi-let (((d-okay undo-stack-2)
;;;;			     (acceptable-as-degenerate-lin
;;;;			        wanted undo-stack envw)))
;;;;		   (cond (d-okay
;;;;			  (finish
;;;;			     got
;;;;			     (type-must-find-feature
;;;;			        wanted 'cartype envw)
;;;;			     undo-stack-2))
;;;;			 (t
;;;;			  (fail-and-undo undo-stack-2 undo-stack)))))
	       (t
		(values false undo-stack)))
       
       :where
       
	 (finish (gty wty us)
	    (cond ((or (not gty) (not wty))
		   (dbg-save :run-loud got wanted envg envw)
		   (signal-problem dot-lin-subtyper
		      "Got or wanted lacks cartype or cdrtype"
		      :% 2 "got = " got
		      :% 2 "wanted = " wanted)))
	    (multi-let (((d-okay us2)
			 (type-acceptable
			    ctv gty wty us envg envw accept-stack)))
	       (okay-or-undo d-okay us2 undo-stack))
	    ))))

(class-feature-datafun is-builder ktp-class
   (defun (key-ty must-be-defined vartypes is-tester-stack warn-if-undefined)
      (let ((keyspecs (type-find-feature key-ty 'keyspecs vartypes)))
	 (let ((elem-testers
		  (<# (\\ (ks)
			 (get-is-tester (Argspec-type ks)
					must-be-defined
					vartypes is-tester-stack
					warn-if-undefined))
		      keyspecs)))
	    (cond ((memq false elem-testers)
		   false)
		  (t
		   (let ((fieldvar (gensym))
			 (foundvar (gensym)))
		      `(lambda (x)
			  (multi-let (((,foundvar ,fieldvar)
				       (find-fields
					      x
					      ',(<# Argspec-position
						    keyspecs)
					      ,(len keyspecs))))
			     (and ,foundvar
				  ,(letrec ((apply-testers (tl)
					       (cond ((null tl)
						      '())
						     (t
						      `((,(car tl)
							 (pop ,fieldvar))
							,@(apply-testers
							     (cdr tl)))))))
				      `(and ,@(apply-testers
					        elem-testers)))))))))))))

(defun find-fields (x keywords numkeywords)
   (letrec ()
      (cond ((right-format x numkeywords)
	     (find-them keywords))
	    (t
	     (values false nil)))
    :where
      (right-format (x n)
	 (or (null x)
	     (and (> n 0)
		  (is-Keyword (car x))
		  (not (null (cdr x)))
		  (right-format (cddr x) (- n 1)))))

      (find-them (kl)
	 (cond ((null kl) (values true '()))
	       (t
		(repeat :for ((xl x (cddr xl)))
		 :until (null xl)
		 :result (values false nil)
		 :until (eq (car xl) (car kl))
		 :result (multi-let (((cdr-okay fl)
				     (find-them (cdr kl))))
			   (values cdr-okay
				   (cons (cadr kl) fl)))))))))

(class-feature-datafun equal-tester key-class
   (defun (me other envm envo)
      (key-ktp-equal-tester 'Row me other envm envo)))

(defun key-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (key-ktp-subtyper ctv 'Row got wanted undo-stack envg envw accept-stack))

(declare-class-feature got-me-want-other key-class
   (make-Accept-handler 10 #'key-subtyper))

(declare-class-feature got-other-want-me key-class
   (make-Accept-handler 10 #'key-subtyper))

(class-feature-datafun equal-tester ktp-class
   (defun (me other envm envo)
      (key-ktp-equal-tester 'Row me other envm envo)))

(defun ktp-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (key-ktp-subtyper ctv 'Row got wanted undo-stack envg envw accept-stack))

(declare-class-feature got-me-want-other ktp-class
   (make-Accept-handler 9 #'ktp-subtyper))

(declare-class-feature got-other-want-me ktp-class
   (make-Accept-handler 9 #'ktp-subtyper))

(defun key-ktp-equal-tester (med me other envm envo)
   (and (eq (Type-class other)
	    (cond ((eq med 'Tup) ktp-class*)
		  (t key-class*)))
	(multi-let (((match pairs)
		     (keyspecs-pairs
		        (type-find-feature me 'keyspecs envm)
			(type-find-feature other 'keyspecs envo))))
	   (and match
		(forall (ksp in pairs)
		   (types-equal (car ksp) (cadr ksp)
				envm envo))))))
		      
(defun keyspecs-pairs (ksl1 ksl2)
   (repeat :for ((res '()))
    :until (or (null ksl1) (null ksl2))
    :result (values (and (null ksl1) (null ksl2))
		   res)
    :while (eq (Argspec-position (car ksl1))
	      (Argspec-position (car ksl2)))
      (!= res (cons (tuple (Argspec-type (cadr ksl1))
			   (Argspec-type (cadr ksl2)))
		    *-*))
      (!= ksl1 (cdr *-*))
      (!= ksl2 (cdr *-*))
    else :result (values false res)))

(defun key-ktp-subtyper (ctv med got wanted undo-stack
			 envg envw accept-stack)
   (let ((class (cond ((eq med 'Tup) ktp-class*)
		      (t key-class*))))
      (cond ((and (eq (Type-class got) class)
		  (eq (Type-class wanted) class))
	     (multi-let (((match pairs)
			  (keyspecs-subset (type-feature wanted 'keyspecs)
					   (type-feature got 'keyspecs))))
		(cond (match
		       (repeat :for ((ksp :in pairs) (undo1 undo-stack) okay)
			:result (values true undo1)
			  (!= < okay undo1 >
			      (type-acceptable
			         ctv (cadr ksp) (car ksp)
				 undo1 envg envw accept-stack))
			:while okay
			else :result (values false
					    (undo undo1 undo-stack))))
		      (t
		       (values false undo-stack)))))
	    (t
	     (values false undo-stack)))))
		     
(defun keyspecs-subset (ksl1 ksl2)
   (letrec ((find-keyspec (pos ksl)
	       (cond ((null ksl)
		      (values false '()))
		     ((eq (Argspec-position (car ksl)) pos)
		      (values (car ksl) (cdr ksl)))
		     (t
		      (find-keyspec pos (cdr ksl))))))
      (repeat :for (ks1 ks2 (pairs '()))
       :until (null ksl1)
       :result (values true pairs)
	 (!= ks1 (pop ksl1))
	 (!= < ks2 ksl2 > (find-keyspec (Argspec-position ks1) ksl2))
       :while ks2
	 (!= pairs (cons (tuple (Argspec-type ks1)
				(Argspec-type ks2))
			 *-*))
       else :result (values false nil))))

(defun dot-lin-scope-time-checker (ty scope-time bound-unks undo-stack env)
   (type-features-freevars-scope-check
      ty '(cartype cdrtype)
      scope-time bound-unks undo-stack env))

(declare-class-feature scope-time-checker dot-class
		       #'dot-lin-scope-time-checker)

(declare-class-feature scope-time-checker lin-class
		       #'dot-lin-scope-time-checker)


