;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: dottypes-valtup.lisp,v 1.1 2006/03/09 16:11:02 dvm Exp $

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on :at-run-time %nity/ tuptypes desigsubst)

(eval-when (:compile-toplevel :load-toplevel :execute :slurp-toplevel)
   (export '(Dot Lin make-dot-type)))

;;; As usual, this one expects cartype and cdrtype to be full-fledged
;;; types, not closands.
(defun make-dot-type (med cartype cdrtype vartypes)
   (cond ((and (memq med '(Row Arg Val))
	       (eq cdrtype empty-row-type*))
	  cartype)
	 (t
;;;;	  (dbg-save cartype cdrtype vartypes)
;;;;	  (breakpoint make-dot-type
;;;;		      "cartype = " cartype
;;;;		      t "cdrtype = " cdrtype)
	  (let ((car-desig (type-find-designator cartype vartypes))
		(cdr-desig (type-find-designator cdrtype vartypes)))
	     (cond ((or (eq cartype void-type*)
			(eq cdrtype void-type*))
		    void-type*)
		   (t
		    (multi-let (((class desig)
				 (dot-type-class+desig
				    med car-desig cdr-desig)))
		       (new-Type class
				 desig
				 (freevars-union
				    (type-find-freevars cartype vartypes)
				    (type-find-freevars cdrtype vartypes))
				 univ-type*
				 '()
				 (list (tuple 'cartype
					      (closure-or-closable
						 cartype vartypes
						 false
						 (Type-freevars cartype)))
				       (tuple 'cdrtype
					      (closure-or-closable
						 cdrtype vartypes
						 false
						 (Type-freevars cdrtype)))
				       (tuple 'medium med)
				       (tuple 'kind
					      (dot-medium-kind med)))))))))))

(defun dot-type-class+desig (med car-desig cdr-desig)
   (cond ((eq med 'Row)
;;;;	  (cond ((or (car-eq car-desig 'Unk)
;;;;		     (car-eq cdr-desig 'Unk))
;;;;		 (breakpoint dot-type-class+desig
;;;;		    "car=desig = " car-desig " cdr-desig = " cdr-desig)))
	  (values lin-class*
		  `(Lin ,car-desig ,cdr-desig)))
	 (t
	  (values dot-class*
		  `(Dot ,car-desig ,cdr-desig)))))

(datafun desig-subst Img
   (defun (d bvars env)
      `(img ,(cadr d)
	    ,(desig-subst (caddr d) (append (cadr d) bvars) env)
	    ,(desig-subst (cadddr d) bvars env))))

(defun dot-medium-kind (med)
   (cond ((memq med '(Row Arg Val)) row-type*)
	 (t type-tup-type*)))



