;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: findvars.lisp,v 1.3 2004/02/22 00:47:00 dvm Exp $

(depends-on %module/ ytools %ytools/ nilscompat)

(depends-on :at-run-time %nity/ funtypes tuptypes feature vartypes
	                       parmutils)

;; This file now contains nothing but the handlers used by
;; type-find-tvars, which is now located in file 'istester'.

(in-type-system universal)

(defun trivial-tvar-finder (_ _ _ _) '())

(declare-class-feature tvar-finder boring-class #'trivial-tvar-finder)
(declare-class-feature tvar-finder simple-typeform-class #'trivial-tvar-finder)
(declare-class-feature tvar-finder unk-class #'trivial-tvar-finder)
(declare-class-feature tvar-finder boolean-class #'trivial-tvar-finder)
;;; This one may look suspicious, but it kicks in only for unbound
;;; params:
(declare-class-feature tvar-finder param-type-class #'trivial-tvar-finder)

(declare-class-feature tvar-finder const-class #'trivial-tvar-finder)

(class-feature-datafun tvar-finder typeform-class
   (defun (ty st-int vartypes stack)
      (tvars-union (<$ (\\ (a)
			  (cond ((eq (Vartype-type a) type-type*)
				 (type-find-tvars (Vartype-val a)
						  st-int vartypes stack))
				(t '())))
		       (type-find-feature ty 'args vartypes))
       '())))

(class-feature-datafun tvar-finder alt-class
   (defun (ty st-int vartypes stack)
      (tvars-union (<$ (\\ (a) (type-find-tvars a st-int vartypes stack))
		       (type-find-feature ty 'alt-types vartypes))
       '())))

(class-feature-datafun tvar-finder fun-class
   (defun (fty st-int vartypes stack)
      (let ((atype (type-find-feature fty 'argtype vartypes)))
	 (let ((augenv (funtype-declare-placeholder-params
			  fty vartypes)))
	    (let ((rtype (type-find-feature fty 'resulttype augenv)))
	       (tvars-union (type-find-tvars atype st-int vartypes stack)
			    (type-find-tvars rtype st-int augenv stack)))))))

(defun dot-lin-tvar-finder (ty st-int vartypes stack)
   (tvars-union (type-find-tvars (type-find-feature ty 'cartype vartypes)
				 st-int vartypes stack)
		(type-find-tvars (type-find-feature ty 'cdrtype vartypes)
				 st-int vartypes stack)))

(declare-class-feature tvar-finder dot-class #'dot-lin-tvar-finder)
(declare-class-feature tvar-finder lin-class #'dot-lin-tvar-finder)

(defun tup-val-tvar-finder (ty st-int vartypes stack)
   (type-find-tvars (type-find-supertype ty vartypes)
		    st-int vartypes stack))

(declare-class-feature tvar-finder tup-class #'tup-val-tvar-finder)
(declare-class-feature tvar-finder val-class #'tup-val-tvar-finder)

(defun key-tvar-finder (ty st-int vartypes stack)
   (</ (\\ (tvl aspec)
	  (tvars-union tvl
		       (type-find-tvars (Argspec-type aspec)
					st-int vartypes stack)))
       '()
       (type-find-feature ty 'keyspecs vartypes)))

(declare-class-feature tvar-finder ktp-class #'key-tvar-finder)
(declare-class-feature tvar-finder key-class #'key-tvar-finder)

(defun arglistspec-find-tvars (alspec st-int vartypes stack)
   (multiple-value-let (alspec _)
		       (follow-var-ref alspec vartypes)
      (</ (\\ (tvl as)
	     (tvars-union (type-find-tvars (Argspec-type as)
					   st-int vartypes stack)
			  tvl))
	  '()
	  (Arglistspec-argspecs alspec))))

; (class-feature-datafun tvar-finder segment-class
;    (defun (ty st-int vartypes)
;       (multi-let (((sty _)
; 		   (type-find-feature ty 'tup-type vartypes)))
;          (type-find-tvars sty st-int vartypes))))

(class-feature-datafun tvar-finder to-row-class
   (defun (ty st-int vartypes stack)
      (type-find-tvars
         (type-find-feature ty 'source-type vartypes)
         st-int vartypes stack)))

(class-feature-datafun tvar-finder image-class
  (defun (ty st-int vartypes stack)
     (let ((itervars (type-find-feature ty 'template-params vartypes))
	   (tmtype (type-find-feature ty 'template-type vartypes))
	   (args (type-find-feature ty 'template-args vartypes)))
        (</ (\\ (tvl a)
	       (tvars-union (type-find-tvars a st-int vartypes stack)
			    tvl))
	    (type-find-tvars tmtype st-int
			     (env-bindings-append
			        true
				(<# (\\ (itp)
					    (new-Vartype
						 (param-type-varname itp)
						 type-type*
						 '*unbound))
					 itervars)
				vartypes)
			     stack)
	    args))))

;;; These are probably not right.
(class-feature-datafun tvar-finder subtype-class
   (defun (ty st-int vartypes stack)
      (type-find-tvars (Type-super ty) st-int vartypes stack)))

(class-feature-datafun tvar-finder modified-class
   (defun (ty st-int vartypes stack)
      (type-find-tvars (type-find-supertype ty vartypes)
		       st-int vartypes stack)))

