;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: parmsgen.lisp,v 1.10 2005/12/26 20:34:24 dvm Exp $

(depends-on :at-run-time %nity/ vartypes feature)

(eval-when (:compile-toplevel :load-toplevel :slurp-toplevel)
   (export '(arglistspec-arglist arglistspec-arglist-or-typelist
	     arglistspec-typed-arglist high-alspec-args-assembler
	     arg-pos-mode arg-pos-< argspec-type-desig)))

;;; Turn an arglistspec into an ordinary arglist
(defun arglistspec-arglist (als &optional (show-default true))
   `(,@(<# Argspec-name (Arglistspec-required als))
     ,@(cond ((null (Arglistspec-optional als))
	      '())
	     (t
	      `(&optional ,@(<# (\\ (as)
				   (argspec-external as show-default))
				(Arglistspec-optional als)))))
     ,@(cond ((null (Arglistspec-rest als))
	      '())
	     (t
	      `(&rest ,(argspec-external (car (Arglistspec-rest als))
					 false))))
     ,@(cond ((null (Arglistspec-key als))
	      '())
	     (t
	      `(&key ,@(<# (\\ (as)
			      (argspec-external as show-default))
			   (Arglistspec-key als)))))))

(defun arglistspec-arglist-or-typelist (als)
;;;;   (breakpoint arglistspec-arglist-or-typelist
;;;;      "als = " als)
   (let ((l (len (Arglistspec-argspecs als))))
      (cond ((= l 0)
	     ;;'Void
	     '())
	    ((forall (aspec :in (Arglistspec-argspecs als))
		(eq (Argspec-name aspec)
		    '_))
	     (cond ((and (= l 1)
			 (eq (Argspec-mode
			        (car (Arglistspec-argspecs als)))
			     ':required))
		    (argspec-type-desig (car (Arglistspec-argspecs als))))
		   ((repeat :for ((asl (Arglistspec-argspecs als)
				      (cdr asl)))
		     :until (or (null asl) (null (cdr asl)))
		     :result true
		     :until (equal (argspec-type-desig (car asl))
				  (argspec-type-desig (cadr asl)))
		     :result false)
		    (arglistspec-typelist als))
		   (t
		    (arglistspec-typed-arglist als))))
	    (t (arglistspec-typed-arglist als)))))

(defun arglistspec-typelist (als)
   (letrec ()
      (let ((req (Arglistspec-required als))
	    (opt (Arglistspec-optional als))
	    (rst (Arglistspec-rest als))
	    (key (Arglistspec-key als)))
      `(,@(<# argspec-type-desig req)
	,@(cond ((null opt) '())
		(t
		 `(&optional ,@(<# argspec-type-desig opt))))
	,@(cond ((null rst) '())
		(t
		 (let ((rstarg (car rst)))
		    `(&rest
			,(cond ((Argspec-seg-type rstarg)
				`(= ,(argspec-type-desig rstarg)))
			       (t (argspec-type-desig rstarg)))))))
	,@(cond ((null key) '())
		(t
		 `(&key
		      ,@(<! (\\ (keyarg)
			       `(,(Argspec-position keyarg)
				 ,(argspec-type-desig keyarg)))
			    key))))))))

(defun arglistspec-typed-arglist (als)
      (letrec ((argseq (label argspecs current-type prev-seg
			&optional (show-default true))
		  (cond ((null argspecs)
			 (values '() current-type prev-seg))
			(t
			 (let ((aspec (car argspecs)))
			    (let ((next-type (argspec-type-desig aspec))
				  (seg-type (Argspec-seg-type aspec)))
			       (let ((comp-type (cond (seg-type
						       false)
						      (t next-type))))
				  (multiple-value-let (seq last-type last-seg)
						      (argseq '()
							 (cdr argspecs)
							 next-type seg-type)
				     (let ((tt (type-trailer 
						    current-type prev-seg
						    comp-type)))
					(values `(,@tt
						  ,@label
						  ,(argspec-external
						      (car argspecs)
						      show-default) 
						  ,@seq)
						last-type
						last-seg))))))))
		  ;;("Argseq< " out-vals*)))
		  )
	       (type-trailer (prev-type prev-seg next-type)
		  (cond ((and prev-type
			      ;;;;(not (member prev-type suppress))
			      (not (equal prev-type next-type)))
			 `(,(cond (prev-seg '--) (t '-))
			   ,prev-type))
			(t '()))))
	 (multiple-value-let (reqseq last-type _)
			     (argseq '() (Arglistspec-required als)
				     false false)
	    (multiple-value-let (optseq last-type _)
				(argseq '(&optional) (Arglistspec-optional als)
					last-type false)
	       (multiple-value-let (restseq last-type last-seg)
				   (argseq '(&rest) (Arglistspec-rest als)
					   last-type false)
		  (multiple-value-let (keyseq last-type last-seg)
				      (argseq '(&key) (Arglistspec-key als)
					      last-type last-seg)
		     `(,@reqseq
		       ,@optseq
		       ,@restseq
		       ,@keyseq
		       ,@(type-trailer last-type last-seg 'Obj)
		       ,@(include-if (Arglistspec-allow-other-keys als)
				     '&allow-other-keys))))))))

(defun argspec-external (spec &optional (show-default true))
   (let ((name (Argspec-name spec))
	 (kind (Argspec-mode spec))
	 (position (Argspec-position spec))
	 (default (Argspec-default spec))
	 (supplied (Argspec-supplied-param spec)))
      (let ((argname
	       (cond ((or (memq kind '(:required :optional :rest))
			  (is-keyword-version position name))
		      `(,name))
		     (t
		      `(,position ,name))))
	    (argdef
	       (cond ((or (not show-default)
			  (and (memq default '(false nil))
			       (not supplied)))
		      '())
		     (t `(,default))))
	    (argsupp
	       (cond (supplied
		      `(,supplied))
		     (t '()))))
	 (let ((ex `(,@argname ,@argdef ,@argsupp)))
	    (cond ((null (cdr ex))
		   (car ex))
		  (t ex))))))

;;; Given an Arglistspec for a typefun, 
;;; produce a function which, given a list of Vartypes,
;;; produces a designator for the type produced by applying that typefun to the
;;; args represented by the Vartypes.
;;; This is probably too simple (because it assumes that the alspec has no
;;; free variables).
;;; This version works only with "high" alspecs, in which args are denoted by
;;; type designators.
(defun high-alspec-args-assembler (alspec)
   (let ((has-keys
	    (not (null (Arglistspec-key alspec))))
	 (rest-argspec
	    (and (not (null (Arglistspec-rest alspec)))
		 (car (Arglistspec-rest alspec)))))
      (let-fun ()
	 (\\ (vartypes)
;;;;	    (trace-around assemble
;;;;	       (:> "(assemble: " vartypes ")")
	    (let-fun ()
	       `(,@(repeat :for  ((aspec :in (Arglistspec-required alspec)))
		    :collect (find-in-vartypes aspec true))
		 ,@(repeat :for  ((aspec :in (Arglistspec-optional alspec)))
		    :collect (find-in-vartypes aspec false))
		 ,@(cond (has-keys
			  (repeat :for ((aspec :in (Arglistspec-optional alspec)))
			   :within
			     (let ((vt (vartypes-lookup (Argspec-name aspec)
							vartypes)))
				(cond (vt
				       (:continue
					   :list-collect
					      (list (Argspec-position aspec)
						    (high-desig (Vartype-val vt)))))))))
			 (rest-argspec
;;;;			  (dbg-save rest-argspec vartypes)
			  (let ((vt (vartypes-lookup (Argspec-name rest-argspec)
						     vartypes)))
			     ;; Actually, it probably indicates an error if this is missing,
			     ;; but we won't worry about it
			     (cond (vt
				    (let ((vtval (Vartype-val vt)))
				       (cond ((is-Type vtval)
					      (list (high-desig vtval)))
					     ((is-list-of vtval #'is-Type)
					      (<# high-desig vtval))
					     (t vtval))))
				   (t !()))))
			 (t !())))
	     :where
		(find-in-vartypes (aspec required)
		   (let ((vt (vartypes-lookup (Argspec-name aspec)
					      vartypes)))
		      (cond (vt
			     (high-desig (Vartype-val vt)))
			    (required
			     (signal-problem high-alspec-args-assembler
				"Required arg " aspec
				:% " has no value in " vartypes))
			    ((Argspec-default aspec)
			     (high-desig (Argspec-default aspec)))
			    (t type-type*)))))
;;;;	       (:< (val &rest _) "assemble: " val))
	    )
       :where
	 ;; Produce a "representation" of entity e, which is almost
	 ;; certainly a type
	 (high-desig (e)
	    (cond ((is-Type e)
		   (Type-desig e))
		  ((is-Closable e)
		   (high-desig (Closable-thing e)))
		  ((constantp e)
		   e)
		  (t `(quote ,e)))))))

(defun is-keyword-version (sym1 sym2)
   (and (is-Keyword sym1)
	(equal (symbol->string sym1)
	       (symbol->string sym2))))

;;; This is just here because it has to be somewhere.
(defun arg-pos-< (pos1 pos2)
   (let ((s1 (arg-pos-mode pos1))
	 (s2 (arg-pos-mode pos2)))
      (cond ((eq s1 'positional)
	     (cond ((eq s2 ':positional)
		    (< pos1 pos2))
		   (t true)))
	    ((eq s2 ':positional)
	     false)
	    ((eq s1 ':rest)
	     (eq s2 ':keyword))
	    (t
	     false))))

(defun arg-pos-mode (i)
   (cond ((is-Integer i) ':positional)
	 ((is-Keyword i) ':keyword)
	 ((and (consp i) (is-Integer (car i)))
	  ':rest)
	 (t (signal-problem arg-pos-mode :fatal
	       "Meaningless arg position: "
	       i))))

(defun argspec-type-desig (aspec)
   (let ((aty (Argspec-type aspec)))
      (cond ((is-Type-closure aty)
	     (type-find-designator (Type-closure-type aty)
				   (Type-closure-env aty)))
	    ((is-Type aty)
	     (Type-desig aty))
	    ((is-Closable aty)
	     (cond ((is-Type (Closable-thing aty))
		    (Type-desig (Closable-thing aty)))
		   (t
		    (signal-problem argspec-type-desig
		       "Indecipherable Closable " aty))))
	    (t
	     (dbg-save :run-loud aspec aty)
	     (error-break argspec-type-desig :fatal
		"Can't find desig of " aspec " with type " aty)))))
