;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: tupacceptors-valtup.lisp,v 1.4 2006/03/14 15:55:01 dvm Exp $

(depends-on :at-run-time %nity/ dotacceptors tupformers auxdefs vartypes)

(def-op objects-equal (ob1 ob2)
   (equal ob1 ob2))

(defun tup-val-equal-tester (ty1 ty2 env1 env2)
   (and (eq (Type-class ty1) (Type-class ty2))
	(types-equal (type-find-supertype ty1 env1)
		     (type-find-supertype ty2 env2)
		     env1 env2)
	(multi-let (((als1 env1 _)
		     (type-find-feature-spread ty1 'elt-types env1))
		    ((als2 env2 _)
		     (type-find-feature-spread ty2 'elt-types env2)))
	   (and (= (len (Arglistspec-argspecs als1))
		   (len (Arglistspec-argspecs als2)))
		(forall (as1 in (Arglistspec-argspecs als1))
			(as2 in (Arglistspec-argspecs als2))
		   (and (eq (Argspec-name as1)
			    (Argspec-name as2))
			(eq (Argspec-mode as1)
			    (Argspec-mode as2))
			(equal (Argspec-position as1)
			       (Argspec-position as2))
			(types-equal (Argspec-type as1)
				     (Argspec-type as2)
				     env1 env2)
			(objects-equal (Argspec-default as1)
				       (Argspec-default as2))))))))
		   
(declare-class-feature equal-tester tup-class #'tup-val-equal-tester)
(declare-class-feature equal-tester val-class #'tup-val-equal-tester)

;;; We now assume that constructors and slot names are completely irrelevant.
;;; That seems a bit dubious, and would probably not be too difficult
;;; to change.
(defun tup-val-subtyper (ctv got want undo-stack
			     envg envw accept-stack)
   (let ((medg (type-find-feature got 'medium envg))
	 (medw (type-find-feature want 'medium envw))
	 (ur-g (tup-val-to-dot-lin got envg))
	 (ur-w (tup-val-to-dot-lin want envw)))
;;;;      (dbg-save got want envg envw ur-g ur-w medg medw)
;;;;      (breakpoint tup-val-subtyper
;;;;         "Media: " medg 1 medw)
      (cond ((and ur-g ur-w)
	     (cond ((eq medg medw)
		    (type-acceptable
			  ctv ur-g ur-w
			  undo-stack envg envw accept-stack))
		   (t
		    (values false undo-stack))))
;;; y no longer matches (Val y), where y is some type.
;;;;	    ((and ur-w (eq medw 'Row))
;;;;	     (type-acceptable ctv got ur-w undo-stack envg envw accept-stack))
	    (t
	     (values false undo-stack)))))

(declare-class-feature got-me-want-other tup-class
   (make-Accept-handler 14 #'tup-val-subtyper))

(declare-class-feature got-other-want-me tup-class
   (make-Accept-handler 14 #'tup-val-subtyper))

(declare-class-feature got-other-want-me val-class
   (make-Accept-handler 15 #'tup-val-subtyper))

(declare-class-feature got-me-want-other val-class
   (make-Accept-handler 15 #'tup-val-subtyper))

;;; Returns underlying dot or lin type, or false if there isn't one.
(defun tup-val-to-dot-lin (ty env)
   (let ((tcl (Type-class ty)))
      (cond ((or (eq tcl tup-class*)
		 (eq tcl val-class*))
	     (type-find-supertype ty env))
	    ((or (eq tcl dot-class*)
		 (eq tcl lin-class*))
	     ty)
	    (t false))))

;;; Not used, but might be handy.
(defun tup-val-class (ty)
   (let ((cl (Type-class ty)))
      (cond ((eq cl tup-class*) 'Tup)
	    ((eq cl val-class*) 'Row)
	    (t false))))

(class-feature-datafun equal-tester constructed-class
   (defun :^ (ty1 ty2 env1 env2)
      (and (eq (Type-class ty1) constructed-class*)
	   (eq (Type-class ty2) constructed-class*)
	   (let ((c1 (type-find-feature ty1 'constructor env1))
		 (c2 (type-find-feature ty2 'constructor env2))
		 (vtl1 (type-must-find-feature ty1 'arg-vartypes env1))
		 (vtl2 (type-must-find-feature ty2 'arg-vartypes env2)))
	      (and c1 c2
		   (eq (Constructor-spec-tyfun c1)
		       (Constructor-spec-tyfun c2))
		   (repeat :for ((vt1 :in vtl1))
		    :result true
		    :while
		       (let ((vt2 (vartypes-lookup (Vartype-var vt1)
						   vtl2)))
			  (cond (vt2
				 (types-equal (Vartype-val vt1)
					      (Vartype-val vt2)
					      env1 env2))
				(t
				 (signal-problem constructed-class-types-equal
				    "Two constructed types of same class differ on"
				    " variable " (Vartype-val vt1)
				    :% " Has it: " ty1
				    :% " Doesn't: " ty2
				    (:continue !"I'll conclude the two types are ~
                                                 not equal"))
				 false)))))))))

(defun constructed-subtyper (ctv got want undo-stack envg envw accept-stack)
   (let ((csg (type-find-feature got 'constructor envg))
	 (csw (type-find-feature want 'constructor envw)))
      (cond ((and csg csw
		  (eq (Constructor-spec-tyfun csg)
		      (Constructor-spec-tyfun csw)))
	     (let ((vtl-g (type-must-find-feature got 'arg-vartypes envg))
		   (vtl-w (type-must-find-feature want 'arg-vartypes envw)))
		(repeat :for ((vtw :in vtl-w)
			      (ustack undo-stack)
			      okay)
		 :result (values true ustack)
		 :while (let ((vtg (vartypes-lookup (Vartype-var vtw)
						    vtl-g)))
			   (cond (vtg
				  (!= < okay ustack >
				      (type-acceptable
				         ctv (Vartype-val vtg)
					     (Vartype-val vtw)
					     ustack envg envw accept-stack))
				  okay)
				 (t
				  (signal-problem constructed-subtyper
				     "Two constructed types of same class"
				     " differ on variable " (Vartype-val vtw)
				     :% " Wants it: " want
				     :% " Doesn't have it: " got
				    (:continue !"I'll conclude the second is~
                                                 not acceptable when the first
                                                 is required"))
				  false)))
		 :result (values false (undo ustack undo-stack)))))
	    (t
	     (values false undo-stack)))))

(declare-class-feature got-me-want-other constructed-class
		       (make-Accept-handler 14 #'constructed-subtyper))

(declare-class-feature got-other-want-me constructed-class
		       (make-Accept-handler 14 #'constructed-subtyper))

;;; This is here because Tups and Rows used to be modified Dots and Lins.

(class-feature-datafun equal-tester modified-class
   (defun (clump1 clump2 e1 e2)
      (multi-let (((clump1 e1)
		   (follow-var-ref clump1 e1))
		  ((clump2 e2)
		   (follow-var-ref clump2 e2)))
	 (and (eq (Type-class clump1) modified-class*)
	      (eq (Type-class clump2) modified-class*)
	      (types-equal (type-find-supertype clump1 e1)
			   (type-find-supertype clump2 e2)
			   e1 e2)    
	      (let ((eq1 (type-find-feature clump1
					    'mod-equal-tester
					    e1))
		    (eq2 (type-find-feature clump2
					    'mod-equal-tester
					    e2)))
		 (cond (eq1
			(loadable-function-call
			   eq1 clump1 clump2 e1 e2))
		       (eq2
			(loadable-function-call
			   eq2 clump2 clump1 e2 e1))
		       (t true)))))))
					  
(defun compare-patches (ty1 ty2 env1 env2)
   (multiple-value-let (p1 found-p1)
		       (type-find-feature ty1 'patches env1)
      (multiple-value-let (p2 found-p2)
			  (type-find-feature ty2 'patches env2)
	 (cond (found-p1
		(and found-p2
		     (patches-same p1 p2)))
	       (t (not found-p2))))))

(defun patches-same (pl1 pl2)
   (repeat :for ((p1 :in pl1) p2
		;; We do it this way to make sure pl2 is copied:
		(pl2 (<! (\\ (p2)
			    (cond ((car-eq p2 'conser)
				   '())
				  (t (list p2))))
			 pl2)))
    :result (null pl2)
    :until (null pl2)
    :result false
      (cond ((car-eq p1 'conser)
	     ;; consers don't distinguish otherwise identical
	     ;; types
	     (!= p2 true))
	    (t
	     (let ((tl2 (member  p1 pl2 :test #'equal)))
		(cond (tl2
		       (!= p2 (car tl2))
		       (!= pl2 (dremove1q p2 *-*)))
		      (t
		       (!= p2 false))))))
    :while p2
    else :result false))

(defun mod-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (let ((g-is-mod (eq (Type-class got) modified-class*))
	 (w-is-mod (eq (Type-class wanted) modified-class*)))
      (multi-let (((bases-okay undo-stack-1)
		   (type-acceptable
		      ctv
		      (cond (g-is-mod (type-find-supertype got envg))
			    (t got))
		      (cond (w-is-mod (type-find-supertype wanted envw))
			    (t wanted))
		      undo-stack
		      envg envw accept-stack)))
	 (cond (bases-okay
		(cond (w-is-mod
		       (let ((w-extra (type-find-feature
					 wanted 'mod-got-other-want-me envw)))
			  (cond (w-extra
				 (multi-let (((w-ex-okay undo-stack-2)
					      (loadable-function-call
						 w-extra ctv got wanted
						 undo-stack-1 envg envw
						 accept-stack)))
				    (cond (w-ex-okay
					   (cond (g-is-mod
						  (got-mod-subtyper
						     ctv got wanted
						     undo-stack-2 undo-stack
						     envg envw accept-stack))
						 (t
						  (values true undo-stack-2))))
							  
					  (t
					   (values false
						   (undo undo-stack-2
							 undo-stack))))))
				(t
				 (values false
					 (undo undo-stack-1 undo-stack))))))
		      (g-is-mod
		       (got-mod-subtyper ctv got wanted
					 undo-stack-1 undo-stack
					 envg envw accept-stack))
		      (t (values true undo-stack-1))))
	       (t
		(values false (undo undo-stack-1 undo-stack)))))))

(defun got-mod-subtyper (ctv got wanted undo-stack-2 undo-stack
			 envg envw accept-stack)
   (let ((g-extra (type-find-feature
		     got 'mod-got-me-want-other envw)))
      (cond (g-extra
	     (multi-let (((g-ex-okay undo-stack-3)
			  (loadable-function-call
			     g-extra ctv got wanted undo-stack-2
			     envg envw accept-stack)))
		(okay-or-undo g-ex-okay undo-stack-3 undo-stack)))
	    (t
	     (values true undo-stack-2)))))

(declare-class-feature got-me-want-other modified-class
   (make-Accept-handler 99 #'mod-subtyper))

(declare-class-feature got-other-want-me modified-class
   (make-Accept-handler 99 #'mod-subtyper))

(defun patches-subtyper (_ got wanted undo-stack _ _ _)
   (let ((pl1 (type-feature got 'patches))
	 (pl2 (type-feature wanted 'patches)))
      (values
	 (cond (pl2
		(cond ((or (null pl2) (and pl1 (not (null pl1))))
		       (forall (p2 in pl2)
			  (or (matchq (conser ?@_) p2)
			      (member  p2 pl1 :test #'equal))))
		      (t false)))
	       (t true))
	 undo-stack)))

(class-feature-datafun equal-tester to-row-class
   (defun (me other envm envo)
      (let ((mydot (type-find-feature me 'source-type envm))
	    (other-class (Type-class other)))
	 (cond ((eq other-class to-row-class*)
		(types-equal
		   mydot
		   (type-find-feature other 'source-type envo)
		   envm envo))
	       ((eq other-class lin-class*)
		(splittables-equal me other true envm envo))
	       (t false)))))

(defun to-row-subtyper (ctv ty1 ty2 undo-stack env1 env2 accept-stack)
   (multi-let ((class1 (Type-class ty1))
	       (class2 (Type-class ty2))
	       ((source1 s-env1 found1)
		(type-find-feature-spread ty1 'source-type env1))
	       ((source2 s-env2 found2)
		(type-find-feature-spread ty2 'source-type env2)))
      (cond ((and (eq class1 to-row-class*)
		  (eq class2 to-row-class*))
	     (cond ((not (and found1 found2))
		    (signal-problem to-row-subtyper
		       "Fumbled features of to-row type")))
	     (type-acceptable
	        ctv source1 source2 undo-stack s-env1 s-env2 accept-stack))
	    ((eq ty1 empty-row-type*)
	     (type-acceptable ctv empty-tup-type* source2
			      undo-stack env1 s-env2 accept-stack))
	    ((eq ty2 empty-row-type*)
	     (type-acceptable ctv source1 empty-tup-type*
			      undo-stack s-env1 env2 accept-stack))
	    (t
	     (splittables-subtyper ctv ty1 ty2 true undo-stack
				   env1 env2 accept-stack)))))

(declare-class-feature got-me-want-other to-row-class
   (make-Accept-handler 12 #'to-row-subtyper))

(declare-class-feature got-other-want-me to-row-class
   (make-Accept-handler 12 #'to-row-subtyper))

(defparameter splittable-classes*
              (list dot-class* lin-class* image-class* to-row-class*
		    typeform-class* tvar-type-class*))
   
(defparameter tupish-classes*
	      (list dot-class* image-class* typeform-class* tvar-type-class*))

(defparameter rowish-classes*
	      (list lin-class* to-row-class*))

(class-feature-datafun equal-tester image-class
   (defun (me other envm envo)
      (and (boole-eq (memq (Type-class me)
			   rowish-classes*)
		     (memq (Type-class other)
			   rowish-classes*))
	   (splittables-equal me other false envm envo))))

(defun splittables-equal (ty1 ty2 to-row env-1 env-2)
      (multi-let (((splittable-1 car-1 cdr-1 undo-1)
		   (type-tup-split ty1 to-row false '() env-1)))
         (multi-let (((splittable-2 car-2 cdr-2 undo-2)
		      (type-tup-split ty2 to-row false undo-1 env-2)))
	    (cond ((or (not (null undo-1))
		       (not (null undo-2)))
		   (signal-problem image-class-equal-tester
		      "Unexpected nontrivial undo-stack")))
	    (cond ((eq splittable-1 'unknown)
		   (!= splittable-1 false)))
	    (cond ((eq splittable-2 'unknown)
		   (!= splittable-2 false)))
	    (cond ((eq splittable-1 splittable-2)
		   (selq splittable-1
		      (maybe
		       ;; tvar
		       (same-tvar ty1 ty2))
		      (once
		       (and (types-equal car-1 car-2 env-1 env-2)
			    (types-equal cdr-1 cdr-2 env-1 env-2)))
		      (t
		       ;; 'always' is impossible, since we didn't
		       ;; force splitting.
		       ;; 'unknown' was merged into 'false' above.
		       ;; So the only option left is 'false'.
		       ;; Neither is splittable
		       true)))
		  (t false)))))

(defun image-subtyper (ctv got wanted undo-stack envg envw accept-stack)
   (splittables-subtyper
      ctv got wanted false undo-stack envg envw accept-stack))

(defun splittables-subtyper (ctv got wanted to-row undo-stack
			     envg envw accept-stack)
   (multi-let (((splg carg cdrg undo1)
		(type-tup-split got to-row ctv undo-stack envg)))
      (multi-let (((splw carw cdrw undo2)
		   (type-tup-split wanted to-row ctv undo1 envw)))
	 (cond ((not (and splg splw))
		(cond ((memq splg '(always maybe))
		       ;; got was a tvar or something consisting entirely
		       ;; of a tvar (e.g., (<R< tvar) ).
		       (undo undo2 undo-stack)
		       ;; (note that undo2 must be = undo1 in this case)
		       (type-acceptable ctv
					(extract-tvar got envg)
					wanted undo-stack envg envw
					accept-stack))
		      ((memq splw '(always maybe))
		       ;; ditto for wanted
		       (undo undo2 undo-stack)
		       (type-acceptable ctv got
					(extract-tvar wanted envw)
					undo-stack envg envw
					accept-stack))
		      (t
		       (okay-or-undo (not (or splg splw)) undo2 undo-stack))))
	       ((or (eq splg 'unknown)
		    (eq splw 'unknown)
		    (and (eq splg 'maybe)
			 (eq splw 'maybe)))
		(undo undo2 undo-stack)
		(try-image-structure-match
		   ctv got wanted undo-stack envg envw accept-stack))
	       ((or (eq splg 'once) (eq splw 'once))
		;; At most one of them is 'maybe', because the case
		;; where both are is caught by the previous clause.
		(cond ((eq splg 'maybe)
		       (!= < splg carg cdrg undo2 >
			   (type-tup-split got to-row true undo2 envg)))
		      ((eq splw 'maybe)
		       (!= < splw carw cdrw undo2 >
			   (type-tup-split wanted to-row true undo2 envg))))
		(cond ((and splg splw)
		       (multi-let (((car-ok undo3)
				    (type-acceptable ctv carg carw undo2
						     envg envw accept-stack)))
			  (cond (car-ok
				 (multi-let (((cdr-ok undo4)
					      (type-acceptable
					         ctv cdrg cdrw undo3
						 envg envw
						 accept-stack)))
				    (okay-or-undo cdr-ok undo4 undo-stack)))
				(t
				 (values false (undo undo3 undo-stack))))))
		      (t
		       (values false (undo undo2 undo-stack)))))
	       (t
		;; Both are 'always'.  Not clear that this can actually
		;; happen.
		(undo undo2 undo-stack)
		(try-image-structure-match
		   ctv got wanted undo-stack envg envw accept-stack))))))

(declare-class-feature got-me-want-other image-class
   (make-Accept-handler 12 #'image-subtyper))

(declare-class-feature got-other-want-me image-class
   (make-Accept-handler 12 #'image-subtyper))

;; Try to split into car and cdr.  Return < splittable, car, cdr, undo-stack >.
;; splittable is false, unknown, maybe, once, or always.
;; Always means we could keep splitting forever
;; Unknown means we encountered something (such as an Unk) whose identity
;; is too obscure to tell whether it's splittable or not.
;; Maybe means we hit a variable that is probably splittable if we force
;; it.
;; Once just means we hit a garden-variety Dot and peeled off its cartype.
;; False means we hit an obvious Null.

;; If force = true, and tt is an unbound tvar, we introduce variables to
;; split it, and return 'always'.
;; In all other cases, force is irrelevant.

;;; If to-row = true, we're in a Row context (as in 'typecheck') and 
;;; any non-Row $u$ should be treated as if it were '(Lin $u$ empty-row)'.
;;; THIS SHOULD BE OBSOLETE IN THE valtup WORLD

;;; 'type-tup-split' requires an undo-stack, because it's usually called inside
;;; try-accept.

(defun type-tup-split (tt to-row force undo-stack env)
   (multi-let (((tt env)
		(follow-var-ref tt env)))
      (multi-let (((cartype foundcar)
		   (get-typetup-piece tt 'cartype to-row env))
		  ((cdrtype foundcdr)
		   (get-typetup-piece tt 'cdrtype to-row env)))
	 (cond ((or foundcar foundcdr)
		(cond ((and foundcar foundcdr)
		       (values 'once
			       (new-Type-closure cartype env)
			       (new-Type-closure cdrtype env)
			       undo-stack))
		      (t
		       (signal-problem type-tupe-split
			  "cartype-cdr screwup: "
			  :% " cartype = " cartype
			  :% " cdrtype = " cdrtype))))
	       ((eq (Type-class tt) image-class*)
		(image-type-split tt force undo-stack env))
	       ((eq (Type-class tt) to-row-class*)
		(cond (to-row
		       (to-row-type-split tt force undo-stack env))
		      (t
		       (signal-problem type-tup-split
			  "to-row type not going to row"))))
	       ((eq (Type-class tt) typeform-class*)
		(type-tup-split (type-find-feature tt 'expansion env)
				to-row
				force
				undo-stack
				env))
	       ((is-tvar-type tt)
		(cond (force
		       (tvar-type-split tt undo-stack env))
		      (t
		       (values 'maybe nil nil undo-stack))))
	       ((eq tt empty-row-type*)
		(cond ((not to-row)
		       (signal-problem type-tup-split
			  "Empty row where tuple expected"
			  (:novalue "I'll treat it as the empty tuple"))))
		(values false nil nil undo-stack))
	       (to-row
		(values 'once (new-Type-closure tt env)
			empty-row-type* undo-stack)) 
	       ((eq tt empty-tup-type*)
		(values false nil nil undo-stack))
	       (t
		(values 'unknown nil nil undo-stack))))))

(defun get-typetup-piece (tt piece to-row env)
;;;;   (cond (to-row
;;;;	  (cond ((eq (Type-class tt) lin-class*)
;;;;		 (type-find-feature tt piece env))
;;;;		(t
;;;;		 (values nil false))))
;;;;	 (t ...))
   (type-find-feature tt piece env))

(defun image-type-split (tt force undo-stack env)
   (multi-let (((pl _)
		(type-find-feature tt 'template-params env))
	       ((al _)
		(type-find-feature tt 'template-args env))
	       ((tm _)
		(type-find-feature tt 'template-type env)))
      (cond ((is-Type-closure tm)
	     (dbg-save :run-loud tt env)
	     (breakpoint image-type-split
		"Uh-oh: " tm)))
      ;; Note that tm is normally a type with freevars and *no env*.
      ;; It acquires an env below.      
      (repeat :for ((p :in pl)
		    (a :in al)
		    (splittable 'always)
		    ;; We will return the "minimum" splittability,
		    ;; under the ordering
		    ;; false < unknown < maybe < once < always
		    ;; So we start with 'always'.
		    (new-env env) (new-args '())
		    (us undo-stack))
       :result (values splittable
		      (new-Type-closure tm new-env)
		      (make-image-type pl tm (reverse new-args) false env)
		      us)
	 (multi-let (((ok subcar subcdr us1)
		      (type-tup-split a false force us env)))
	    (cond ((memq ok '(once always))
		   (!= new-env (env-cons
				  (new-Vartype (param-type-varname p)
					       type-type*
					       subcar)
				  *-*))
		   (!= new-args (cons subcdr *-*))
		   (!= us us1)))
	    (!= splittable (splittable-min *-* ok)))
       :until (or (not splittable)
		 (memq splittable '(unknown maybe)))
       else :result (values splittable nil nil (undo us undo-stack)))))

(defun splittable-min (spl1 spl2)
   (let ((tl2 (memq spl2 '(#.false unknown maybe once always))))
      (cond (tl2
	     (cond ((memq spl1 tl2)
		    spl2)
		   (t spl1)))
	    (t
	     (signal-problem splittable-min
		"Illegal splittability " spl2)))))

(defun to-row-type-split (tt force undo-stack env)
   (err-out "Splitting a to-row " tt)
   (multi-let (((o-splittable o-car o-cdr o-undo)
		(type-tup-split (type-find-feature tt 'source-type env)
				false force undo-stack env)))
      (values o-splittable o-car
	      (cond ((memq o-splittable '(once always))
		     (let ((seed (type-place-seed tt env)))
		        (let ((new-cdr (make-to-row-type o-cdr env)))
			   (!= (type-feature new-cdr 'seed) seed)
			   new-cdr)))
		    (t nil))
	      o-undo)))

(defun tvar-type-split (tt undo0 env)
   (!= scope-time* (+ *-* 1))   
   (let ((av (anon-tvar ':t true type-type*))
	 (dv (anon-tvar ':l true type-tup-type*)))
      (let ((nt (make-dot-type 'Tup av dv env)))
         (multi-let (((ok undo1)
		      (accept-as-equal true tt nt undo0 env env '())))
	    (cond (ok
		   (dbg-out binding-dbg*
		      "Created new tvars ?" (tvar-type-varname av)
		      ", ?" (tvar-type-varname dv)
		      " to split " tt :%)
		   (let ((seed (type-place-seed tt env)))
		      (!= (type-feature av 'seed) seed)
		      (!= (type-feature dv 'seed) seed))
		   (values 'always av dv undo1))
		  (t
		   (values false nil nil (undo undo1 undo0))))))))

(defun try-image-structure-match (ctv got want undo0 envg envw accept-stack)
   (multi-let (((foundg tpg ttg tag)
		(img-features got envg)))
      (cond (foundg
	     (multi-let (((foundw tpw ttw taw)
			  (img-features want envw)))
	        (cond ((and foundw
			    (= (len tag)
			       (len taw))
			    (image-templates-could-match
			       ctv tpg tpw ttg ttw undo0 envg envw
			       accept-stack got want))
		       (type-lists-acceptable
			  ctv tag taw
			  undo0 envg envw accept-stack))
		      (t
		       (values false undo0)))))
	    (t
	     (values false undo0)))))   
   
(defun img-features (ty env)
   (multi-let (((tparms found)
		(type-find-feature ty 'template-params env)))
      (cond (found
	     (multi-let (((ttype found-t)
			  (type-find-feature ty 'template-type env))
			 ((targs found-a)
			  (type-find-feature ty 'template-args env)))
		(cond ((and found-t found-a)
		       (values true tparms ttype targs))
		      (t
		       ;; This should perhaps signal an error.
		       (values false nil nil nil)))))
	    (t
	     (values false nil nil nil)))))

(defun image-templates-could-match (ctv tpg tpw ttg ttw
				    undo0 envg envw accept-stack
				    orig-g orig-w)
   (let ((genv (img-params-bind-to-tvars tpg envg
					 orig-g "acceptable as" orig-w))
	 (wenv (img-params-bind-to-tvars tpw envw orig-w "accept" orig-g)))
      (multiple-value-let (okay undo1)
			  (type-acceptable ctv ttg ttw undo0
					   genv wenv accept-stack)
	    ;; We undo because this is all hypothetical.
	    (undo undo1 undo0)
	    okay)))

(defun img-params-bind-to-tvars (params env rel this-ty other-ty)
   (env-bindings-append
      true
      (params-to-tvars params this-ty rel other-ty)
      env))

(defun params-to-tvars (params this-ty rel other-ty)
   (cond ((null params)
	  (error-break params-to-tvars :fatal
	     "Null params")))
   (let ((new-vts
	    (<# (\\ (p)
		   (new-Vartype (param-type-varname p)
				type-type*
				(anon-tvar 'seg-elt false type-type*)))
		params)))
      (cond (binding-dbg*
	     (out (:to *error-output*) "Creating new tvar(s)")
	     (repeat :for ((vt :in new-vts))
		(out (:to *error-output*) " ?" (tvar-type-varname (Vartype-val vt))))
	     (out (:to *error-output*)
		:% "  to try to make "
		this-ty 
		:% 1 (:a rel) 1 other-ty :%)))
      new-vts))

(defun extract-tvar (ty env)
   (multi-let (((ty env)
		(follow-var-ref ty env)))
      (cond ((is-tvar-type ty)
	     ty)
	    ((eq (Type-class ty) to-row-class*)
	     (extract-tvar (type-find-feature ty 'source-type env)
			   env))
	    ((eq (Type-class ty) image-class*)
	     (let ((image-args (type-find-feature ty 'template-args env)))
		(cond ((= (len image-args) 1)
		       (extract-tvar (car image-args) env))
		      (t
		       (signal-problem extract-tvar :fatal
			  "Can't handle image type with multiple args: "
			  ty)))))
	    (t
	     (signal-problem extract-tvar
		"Can't find tvar in haystack " ty)))))

(class-feature-datafun scope-time-checker to-row-class
   (defun (ty scope-time bound-unks undo-stack env)
      (all-freevars-scope-okay
         (type-find-feature ty 'source-type env)
	 scope-time bound-unks undo-stack env)))

(declare-class-feature scope-time-checker tup-class
		       #'supertype-scope-time-checker)
(declare-class-feature scope-time-checker val-class
		       #'supertype-scope-time-checker)

(declare-class-feature scope-time-checker modified-class
		       #'supertype-scope-time-checker)
(declare-class-feature scope-time-checker subtype-class
		       #'supertype-scope-time-checker)

(class-feature-datafun scope-time-checker image-class
   (defun (ty scope-time bound-unks undo-stack env)
      (typelist-freevars-scope-check
         (type-find-feature ty 'template-args env)
         scope-time bound-unks undo-stack env)))

