;-*- Mode: Common-lisp; Package: nity; Readtable: ytools; -*-
(in-package :nity)
;;; $Id: tupformers-valtup.lisp,v 1.4 2006/03/10 15:46:58 dvm Exp $

(depends-on :at-run-time %nity/ desig parmsparse parmutils tuptypes
				auxdefs parmsgen
			 %langutils/ synutils)

(eval-when (:load-toplevel :compile-toplevel :slurp-toplevel)
   (export '(make-tup-type make-constructed-type type-constructor-apply
             is-constructed-type
	     constructed-type-tyfun constructed-type-argtypes)))

(in-type-system universal)

(def-type-former Tup (elemtypes typename vartypes)
  (nth-value 0
     (tup-val-former 'Tup elemtypes typename univ-type* vartypes)))

(def-type-former Val (elemtypes typename vartypes)
   (nth-value 0
      (tup-val-former 'Row elemtypes typename univ-type* vartypes)))

(defun tup-val-former (med elemtypes typename default-type vartypes)
   (multiple-value-let (alspec _ new-tvars synerrs)
		       (params-parse elemtypes false default-type
				     true false vartypes)
      (cond ((not (null synerrs))
	     (note-defective-exp ((_)
				  "Syntax errors in tuple " elemtypes
				  :% synerrs)
		:target alspec
		:place tup-val-type-former
		(:novalue "I will try :to ignore them"))))
      (values (make-tup-type med alspec typename vartypes)
	      alspec
	      new-tvars)))

(defun make-tup-type (med alspec slot-pref env)
   (multi-let (((alspec env)
		(follow-var-ref alspec env)))
      (let ((freevars (env-freevars (arglistspec-freevars alspec)
                                       env (not (Env-is-closing env)))))
         (let ((sup-type (alspec-dotify med alspec env)))
            (new-Type (cond ((eq med 'Tup) tup-class*)
                            (t val-class*))
                      `(,(cond ((eq med 'Tup) 'Tup)
                               (t 'Val))
                        ,@(arglistspec-typed-arglist alspec))
                      freevars
                      sup-type
                      (cons (tup-val-conser med slot-pref alspec freevars)
                            (<! (\\ (as)
                                    (tup-val-slot med slot-pref as
                                                  alspec))
                                (Arglistspec-argspecs alspec)))
                      (list (tuple 'medium med)
                            (tuple 'kind (cond ((eq med 'Tup) type-type*)
                                               (t type-tup-type*)))
                            (tuple 'elt-types
                                   (closure-or-closable
                                    alspec env
                                    'arglistspec-close freevars))))))))

(defun tup-val-conser (med typename alspec freevars)
   (make-Slot 'conser
	      (cond ((and (null (Arglistspec-optional alspec))
			  (null (Arglistspec-key alspec)))
		     (cond ((null (Arglistspec-rest alspec))
			    (cond ((eq med 'Tup)
				   'list)
				  ((= (len (Arglistspec-required alspec))
				      1)
				   'cr)
				  (t
				   'values)))
			   (t
			    (cond ((eq med 'Tup)
				   `(:inline (&rest l)
				       (apply #'list l)))
				  (t
				   `(:inline (&rest l)
				       (apply #'values l)))))))
		    (t
		     (let ((alspec (arglistspec-rename-_ alspec)))
			(lambda-or-aux-def typename
					   (build-symbol make- (< typename))
			   `(,(arglistspec-arglist alspec true)
			     (,@(cond ((null (Arglistspec-rest alspec))
				       (cond ((eq med 'Tup)
					      '(list))
					     (t
					      '(values))))
				      (t
				       (cond ((eq med 'Tup)
					      '(apply #'list))
					     (t
					      '(apply #'values)))))
			      ,@(<# Argspec-name
				    (Arglistspec-required alspec))
			      ,@(<# Argspec-name
				    (Arglistspec-optional alspec))
			      ,@(cond ((null (Arglistspec-key alspec))
				       (cond ((null (Arglistspec-rest
						       alspec))
					      '())
					     (t
					      `(,(Argspec-name
						    (car (Arglistspec-rest
							    alspec)))))))
				      (t
				       (<$ (\\ (as)
					      `(',(Argspec-position
						     as)
						,(Argspec-name as)))
					   (Arglistspec-key alspec))))))))))
	      false false
	      (new-Closable alspec freevars
			    (simple-loadable-function arglistspec-close))
	      false `(conser ,@(arglistspec-arglist alspec))))

(defun arglistspec-rename-_ (alspec)
   (cond ((exists (spec :in (Arglistspec-argspecs alspec))
	     (eq (Argspec-name spec) '_))
	  (new-Arglistspec
	     (<# (\\ (spec)
		    (make-Argspec
 		       (let ((n (Argspec-name spec)))
			  (cond ((eq n '_)
				 (gensym))
				(t n)))
		       (Argspec-mode spec)
		       (argspec-pos-zero spec)
		       (Argspec-type spec)
		       (Argspec-default spec)
		       (<# (\\ (p)
			      (tuple (car p) (cadr p)))
			   (Argspec-props spec))))
		 (Arglistspec-argspecs alspec))))
	 (t alspec)))

;;; Actually returns a list of slots, because there may not be
;;; any, and because some have multiple names.
(defun tup-val-slot (med typename as alspec)
   (letrec ()
      (cond ((eq med 'Row)
	     (cond ((eq (Argspec-mode as) ':rest)
		    '())
		   ((and (eq (Argspec-mode as) ':required)
			 (forall (as :in (Arglistspec-argspecs alspec))
			    (equal (Argspec-position as)
				   1)))
		    (let ((namelist (argspec-names as)))
		       (repeat :for ((name :in namelist))
			:collect
			     (make-Slot name 'cr false
					(make-type-closable
					   (Argspec-type as)
					   false)
					no-args-spec*
					(simple-loadable-function
					   no-brainer-invert)
					`(,name 0)))))
		   (t
		    (regular-tup-val-slot))))
	    (t
	     (regular-tup-val-slot)))

    :where

      (regular-tup-val-slot ()
	 (let ((pos (Argspec-position as))
	       (namelist (argspec-names as)))
	    (repeat :for ((name :in namelist))
	     :collect
		  (make-Slot name
			     (position-fun-name med pos)
			     (and (eq med 'Tup)
				  (position-setter-name
				     typename pos))
			     (argspec-slot-type-closable as)
			     no-args-spec*
			     (make-Loadable-function-with-extras
				:name 'tup-val-pos-type-invert
				:fcn false
				:towit (list med pos alspec))
			     `(,name ,pos)))))))

(defun argspec-slot-type-closable (as)
   (let ((aty (make-type-closable (Argspec-type as) false)))
      (cond ((and (eq (Argspec-mode as)
		      ':rest)
		  (not (Argspec-seg-type as)))
	     (make-type-closable (make-lstype aty) false))
	    (t aty))))

(defun no-brainer-invert (type args)
   (values true (list (new-Vartype (car args) type false))))	   

;;; 'as-pos' is position of the Argspec corresponding to this slot.
(defun tup-val-pos-type-invert (med as-pos alspec)
   (\\ (type args)
      (values true
	      (list (new-Vartype
		       (car args)
		       (make-tup-type
			  med
			  (new-Arglistspec
			     (<# (\\ (as)
				    (cond ((equal (Argspec-position as)
						  as-pos)
					   (argspec-with-new-type as type))
					  (t (argspec-copy as))))
				 (Arglistspec-argspecs alspec)))
			  false empty-env*)
		       false)))))

(defun argspec-with-new-type (argspec type)
   (make-Argspec
      (Argspec-name argspec)
      (Argspec-mode argspec)
      (argspec-pos-zero argspec)
      type
      (Argspec-default argspec)
      (<# #'copy-list (Argspec-props argspec))))

(defun argspec-names (as)
      (let ((default (position-slot-name as (Argspec-position as))))
	 (cond ((eq (Argspec-name as) '_)
		(list default))
	       (t
		(list (Argspec-name as) default)))))
					     
(defun position-slot-name (as pos)
   (cond ((eq (Argspec-mode as) ':rest)
	  (build-symbol "<" (< (car pos)) "..>"))
	 ((is-Keyword pos)
	  (build-symbol "<:" (< pos) ">"))
	 (t
	  (build-symbol "<" (< pos) ">"))))

;;; Can't set a slot of anything but Tup.
(defun position-setter-name (typename pos)
   (cond ((is-Symbol pos)
	  (lambda-or-aux-def
	     typename
	     (build-symbol (< typename) "-:" (< pos) -set)
	     `((l newval)
	       (!= (car (find-field ',pos l))
		   newval)
;;;;	       (let ((fld (find-field ',pos l)))
;;;;		  (cond (fld
;;;;			 (!= (car fld) newval))
;;;;			(t
;;;;			 (signal-problem :place (,pos setter)
;;;;			    "Field " ',pos " missing in tuple"))))
	       )))
	 (t
	  (let ((pf (position-fun-name 'Tup pos)))
	     (match-cond pf
		((atom pf)
		 `(:inline (l newval) (setf (,pf l) newval)))
	       ?( (:inline ?a ?b)
		 `(:inline (,@a newval) (setf ,b newval)))
	       (t
		(signal-problem position-setter-name
		   "Can':t decipher " pf
		   (:novalue "I'll assume it's not settable"))
		false))))))

(defun position-fun-name (med pos)
   (let ((nthacc (cond ((eq med 'Tup) 'nth)
		       (t 'nth-value))))
      (cond ((is-Number pos)
	     (cond ((and (eq med 'Tup) (< pos 5))
		    (elt '(car cadr caddr cadddr) (- pos 1)))
		   (t
		    `(:inline (l)
			(,nthacc ,(- pos 1) l)))))
	    ((matchq (?(+ ?_ is-Number))
		     pos)
	     (let ((pos (car pos)))
		(cond ((< pos 6)
		       (elt '(cr cdr cddr cdddr cddddr) (- pos 1)))
		      (t
		       `(:inline (l) (nthcdr ,(- pos 1) l))))))
	    ((is-Symbol pos)
	     `(:inline (l)
		 (car (find-field ',pos l))
;;;;		 (let ((fld (find-field ',pos l)))
;;;;		    (and fld (car fld)))
		 ))
	    (t
	     (signal-problem position-fun-name
		"Argspec has bad position " pos)))))

;;; Args are much simpler because we can't construct them or 
;;; access their pieces except by calling a function.
(def-type-former Arg (params typename vartypes)
   (not-allowed-in-def-type typename 'Arg)
   (designated-argtype params 0 false univ-type* vartypes))

;;; Returns <type, arglistspec, new-tvars >
(defun designated-argtype (params level require-var-names
			   default-type vartypes)
   (multiple-value-let (arglist-spec _ new-tvars syntax-errors)
		       (cond ((> level 0)
			      (multiple-value-let (alspec synerrs)
						  (high-funargs-argspecs
						     params vartypes)
				 (values alspec '() '() synerrs)))
			     (t
			      (params-parse params require-var-names
					    default-type
					    true true vartypes)))
      (cond ((not (null syntax-errors))
;;;;	     (breakpoint designated-argtype
;;;;		"Noting syntax errors: " syntax-errors)
	     (note-defective-exp ((_) "Syntax errors in params " params
				      :% syntax-errors)
		:target arglist-spec
		:place Tup-type-former
		(:novalue "I will try :to ignore them"))))
      (values
         (arglistspec-argtype arglist-spec vartypes)
	 arglist-spec
	 new-tvars)))

(defun arglistspec-argtype (arglist-spec env)
;;;;	 (cond ((and (null (Arglistspec-optional arglist-spec))
;;;;		     (null (Arglistspec-rest arglist-spec))
;;;;		     (null (Arglistspec-key arglist-spec))
;;;;		     (= (len (Arglistspec-required arglist-spec))
;;;;			1))
;;;;		(new-Type-closure
;;;;		   (Argspec-type
;;;;		      (car (Arglistspec-required arglist-spec)))
;;;;		   env))
;;;;	       (t ...))
   (let ((res-type
            (alspec-dotify 'Row arglist-spec env)))
      (!= (type-feature res-type 'elt-types)
          arglist-spec)
      res-type))

;(defun argtype-arglistspec (ty vartypes)
;   (or (type-find-feature ty 'elt-types vartypes)
;       (args->spec (list (maybe-close ty vartypes)))))

(defun alspec-dotify (med alspec env)
   (let (res-type)
      (cond ((null (Arglistspec-key alspec))
	     (cond ((null (Arglistspec-rest alspec))
		    (!= res-type (empty-type med)))
		   (t
		    (let ((rspec (car (Arglistspec-rest alspec))))
		       (!= res-type
			   (rest-argspec-type med rspec))))))
	    (t
;;;	     (cond ((not (null (Arglistspec-rest alspec)))
;;;		    (note-defective-exp ("&key and &rest in same parameter list: "
;;;				      (arglistspec-typed-arglist alspec))
;;;		       (:novalue "I'll ignore the &rest"))))
	     (!= res-type
		 (build-key-type
		    med
		    (Arglistspec-key alspec)))))
      (repeat :for ((as :in (reverse (append (Arglistspec-required alspec)
					     (Arglistspec-optional alspec)))))
	 (!= res-type
	     (make-dot-type med  ;; Tup or Row
			    (Argspec-type as)
			    *-*
			    env)))
      res-type))

(defun rest-argspec-type (med rspec)
   (let ((aty (Argspec-type rspec)))
      (cond ((Argspec-seg-type rspec)
	     (cond ((eq med 'Tup) aty)
		   (t
                    (signal-problem rest-argspec-type
                       "Encountered seg-type Argspec: " rspec
                       :%
                       " I have a strange urge to build a to-row type; please stop me!"
                       (:proceed "I will build that to-row type!"))
		    (build-to-row-type aty))))
	    ((eq med 'Row)
	     (make-roltype (make-type-closable aty false)))
	    (t
	     (make-lstype (make-type-closable aty false))))))

(defun type-plus-slots (desig ty new-slots vartypes)
   (let ((fvl (Typoid-freevars ty)))
      (let ((new-type
	       (make-type-of-class modified-class
		  (or desig
		      `(+ ,@(type-find-designator ty vartypes) 
			  ,(<# Slot-name new-slots)))
		  fvl
		  (cond ((null fvl)
			 ty)
			(t
			 '*as-feature))
		  new-slots
		  (list (tuple 'just-new-slots true)))))
	 (!= (type-feature new-type 'defined-fun) new-type)
	 (!= (type-feature new-type 'defined-fun-args) '())
	 (!= (type-feature new-type 'patches)
	     (<# (\\ (s) `(,(Slot-name s) ,(get-slot-descriptor s)))
		 new-slots))
	 (!= (type-feature new-type 'mod-got-other-want-me)
	     (simple-loadable-function trivial-mod-extra-subtyper))
	 (!= (type-feature new-type 'mod-got-me-want-other)
	     (simple-loadable-function trivial-mod-extra-subtyper))
;;;;	 (dbg-save :comp-quiet new-type ty vartypes)
;;;;	 (breakpoint type-plus-slots
;;;;	    "Ready to set supertype feature: "(Type-super new-type))
	 (cond ((eq (Type-super new-type) '*as-feature)
		(!= (type-feature new-type 'supertype)
		    ;;(type-close ty vartypes)
		    (make-type-closable ty false))))
	 new-type)))

;;; This has a striking resemblance to 'tyfun-alspec-args-resolve', but
;;; the key difference is that this version works with types, not type
;;; designators.
(defun make-constructed-type (tyfun argtypes vartypes)
   (let ((tdefn (Tyfun-defn tyfun)))
      (cond ((is-Constructor-spec tdefn)
	     (let ((type-alspec (Constructor-spec-type-params tdefn)))
	        (multi-let (((pairs rest-pair pathol)
			     (params-args-pair type-alspec argtypes)))
		   (cond ((not (null pathol))
			  (note-defective-exp
			     ((_) "Syntax errors when matching"
			      :% " parameters " type-alspec
			      :% " :to args " argtypes ":"
			      :% pathol)
			     (:continue "I will ignore them"))))
		   (repeat :for ((as :in (Arglistspec-all-nonrest-argspecs
 					    type-alspec))
				 :collectors arg-vartypes)
		    :within
		      (let ((ap (assq as pairs)))
			 (cond (ap
				(let ((atype (cadr ap)))
				   (:continue
				      :collect (:into arg-vartypes
						      (new-Vartype
							 (Argspec-name as)
							 (type-find-kind
							    atype vartypes)
							 atype)))))
			       (t
				(signal-problem make-constructed-type
				   "Fumbled :required arg " (Argspec-name as) " :in "
				   `(,(Tyfun-name tyfun)
				     ,@(<# Type-desig argtypes))
				   (:novalue "I'll try to do without it")))))
		    :result
		      (let ((rtspec (and rest-pair (first rest-pair))))
			 (cond (rtspec
				(let ((tup-of-types
				         (make-tup-type
					    'Val
					    (args->spec (second rest-pair))
					    "" 
					    vartypes)))
				   (finish-constructed-type
				      tdefn
				      (cons (new-Vartype
					       (Argspec-name rtspec)
					       type-tup-type*
					       tup-of-types)
					    arg-vartypes)
				      vartypes)))
			       (t
				(finish-constructed-type
				   tdefn arg-vartypes vartypes))))))))
	    (t
	     (signal-problem make-constructed-type
		"Not a constructor: " tyfun)))))

;;; This could, and probably should be, generalized to type
;;; constructor with arguments before the &rest argument.
(defun type-constructor-apply (tyfun valtype vartypes)
   (let ((tdefn (Tyfun-defn tyfun)))
      (cond ((is-Constructor-spec tdefn)
	     (let ((type-alspec (Constructor-spec-type-params tdefn)))
                (cond ((and (= (len (Arglistspec-argspecs type-alspec))
                               1)
                            (eq (Argspec-mode (first (Arglistspec-argspecs
                                                        type-alspec)))
                                ':rest))
                       (let ((rest-spec (first (Arglistspec-argspecs
                                                        type-alspec))))
			  (finish-constructed-type
			     tdefn
                             (list (new-Vartype
				      (Argspec-name rest-spec)
                                      type-tup-type*
                                      valtype))
                             vartypes)))
                      (t
                       (signal-problem type-constructor-apply
                          "Constructor " tyfun
                          " has wrong kind of Arglistspec: "
                          :% 3 type-alspec)))))
	    (t
	     (signal-problem type-constructor-apply
		"Not a constructor: " tyfun)))))

(defun designated-constructor-type (constructor-tyfun arg-desigs desig-env)
   (let ((tdefn (Tyfun-defn constructor-tyfun)))
      (make-constructor-typeform
         tdefn
	 (Tyfun-name constructor-tyfun)
	 arg-desigs desig-env)))

(defun is-constructed-type (ty)
   (eq (Type-class ty) constructed-class*))

(defun constructed-type-tyfun (ty env)
   (Constructor-spec-tyfun (type-must-find-feature ty 'constructor env)))

(defun constructed-type-argtypes (ty env)
   (<# Vartype-val (type-must-find-feature ty 'arg-vartypes env)))

(defun trivial-mod-extra-subtyper (_ _ _ undo-stack _ _ _)
   (values true undo-stack))

(class-feature-datafun feature-filler modified-class
   (defun (ty feat vartypes)
      ;; We have to be careful; a call to type-find-feature
      ;; could easily cause an infinite recursion.
      (cond ((eq feat 'supertype)
	     (signal-problem modified-class-feature-filler
		"Can':t find supertype of " ty))
	    ((type-feature ty 'just-new-slots)
	     (let ((ut (type-find-supertype ty vartypes)))
		;; But it's okay to call it on ut
		(type-find-feature ut feat vartypes)))
            (t
	     (values false false)))))

;;; Not used now, but probably will be
(defun alspec-name-map (alspec)
   (<# (\\ (as)
	  (let ((pos (Argspec-position as)))
	     (lrecord (cond ((eq (Argspec-name as) '_)
			     (cond ((eq (Argspec-mode as) ':rest)
				    (build-symbol < (< pos) ".." >))
				   (t
				    (build-symbol < (< pos) >))))
			    (t
			     (Argspec-name as)))
		      pos)))
       alspec))

(def-type-former Feature-type (params _ vartypes)
   (repeat :for ((p :in params))
      (cond ((not (matchq (?(+ ?_ is-Symbol)
			   ?_)
			  p))
	     (signal-problem Feature-type-former
		"Illegal arg: " p))))
   (let ((featnames
	    (<# car params))
	 (defining-types
	    (<# (\\ (p) (designated-type (cadr p) true vartypes))
		params)))
      (make-feat-type featnames defining-types vartypes)))

(defun make-feat-type (featnames defining-types vartypes)
;   (out (tr make-feat-type ("feat> " typename 1 featnames 1 defining-types)
      (make-type-of-class feat-class
	 `(Feature-type ,@(<# (\\ (featname ty)
				 `(,featname
				   ,(type-find-designator ty vartypes)))
			      featnames
			      defining-types))
	 (</ (\\ (params ty)
		(freevars-union params (Typoid-freevars ty)))
	     '() defining-types)
	 univ-type*
	 '()
	 (cons (tuple 'defining-features featnames)
	       (<# (\\ (fname fty)
		      (tuple fname (make-type-closable fty false)))
		   featnames defining-types)))
;      ("feat< " (car out-vals*))))
      )

(defun feat-type-feature (fty featname env)
   (err-out "Calling obsolete function feat-type-feature: "
	    :% fty :% featname :%)
   (type-find-feature fty featname env))

;;;;   (multi-let (((v found)
;;;;		(type-find-feature fty featname env)))
;;;;      (cond ((not found)
;;;;	     (values nil false))
;;;;	    ((and (is-Type-closure v)
;;;;		  (is-param-type (Type-closure-type v)))
;;;;	     (values (one-value (follow-var-ref v env))
;;;;		     true))
;;;;	    (t
;;;;	     (signal-problem feat-type-feature
;;;;		"Unexpected feature value for " featname " of " fty ":"
;;;;		:% v
;;;;		(:novalue "I'll assume the feature is absent"))
;;;;	     (values nil false)))))
